; Pitfall The Mayan Adventure MSU-1 Patch v1.0
;
; Changelog 1.0:
;  - initial release

lorom

; game hooks

org $8E8742
db $00     ; hardcore mute

org $80E154
JSL pauseStart
NOP
NOP


org $80E16B
JSL pauseEnd
NOP
NOP

org $8081B2
JSL muteContinue
NOP
NOP

org $80FC42
JSL MsuTrack

org $80e160
JSL deathbreak
NOP

org $809953
JSL deathresume


; free rom space for patch code
org $03FB60

deathbreak:
	STZ $2007
	STZ $8E
	LDA #$0024
	RTL

deathresume:
	PHP
	SEP #$20
	STZ $2006
	LDA $7efff0
	STA $2004
	STZ $2005
loop2:
	BIT $2000
	BVS loop2
	LDA #$FF
	STA $2006
	LDA #$03
	STA $2007
	PLP
	LDA $1ED0
	INC A 
	RTL
	
pauseStart:
	INC $0312
	STZ $2007 ;mute track
	LDA #$0010
	RTL
pauseEnd:
	STZ $0312
	LDA #$0003 ;loop track
	STA $2007
	LDA #$0012
	RTL

muteContinue:
	LDA $7e021e
	AND #$00FF
	cmp #$0016
	BNE $03
	STZ $2007
	LDA $1EB9
	AND #$00FF
	RTL		
	
MsuTrack:
	PHA
	LDA $2002
	CMP #$53
	BEQ stFoundMsu
	PLA
	LDX #$0700
	STX $2142
	RTL
stFoundMsu:
	PLA
	JSL playTrack
	LDX #$0700
	STX $2142
	RTL

playTrack:	
; ----------------------------------------------------Conn
	PHA
	CMP #$09    ; are we at beginning
	BNE $02
	PLA
	RTL
	CMP #$26    ; are we at boss?
	BNE noBoss
	LDA #$19    ; made this to be the Boss
	JSL msuPlay
	JSL loop
	PLA
	RTL	
noBoss:	
	CMP #$0B    ; are we at stage intro?
	BNE noStageIntro
	LDA $7e021e
	CMP #$16    ; are we at continue
	BNE $04     ; if yes, restore 0B and don't play stage intro
	LDA #$0B
	BRA noStageIntro
	LDA #$20    ; made this to be the intro
	JSL msuPlay
	JSL noloop
	PLA
	RTL
noStageIntro:       
	CMP #$33    ; are we at Bonus Game
	BNE noBonus
	LDA #$21    ; made this to be the Bonus
	JSL msuPlay
	JSL noloop
	PLA
	RTL
noBonus:
	CMP #$08    ; are we at Intro
	BNE noIntro
	LDA #$22    ; made this to be the Intro,pitfall harry kidnapped
	JSL msuPlay
	JSL noloop
	PLA
	RTL
noIntro:	
	CMP #$79    ; are we at End?
	BNE noTitle
	LDA #$23    ; made this to be the End
	JSL msuPlay
	JSL noloop
	PLA
	RTL
noTitle:	
	CMP #$9C    ; are we at Title?
	BNE noEnd
	LDA #$00    ; made this to be the End
	JSL msuPlay
	JSL noloop
	PLA
	RTL
noEnd:
	LDA $7e021e
	JSL msuPlay
	JSL loop
	PLA
	RTL		

loop:
	LDA #$03
	STA $2007
	RTL
noloop:
	LDA #$01
	STA $2007
	RTL

; msu1 playback routine
msuPlay:
	STZ $2006
	STA $2004
	STA $7efff0
	STZ $2005
loopTitle:
	BIT $2000
	BVS loopTitle
	LDA #$FF
	STA $2006
	RTL
	
	
	; Pev code for credits
	
	; Pitfall The Mayan Adventure MSU-1 Patch v1.0
;
; Changelog 1.0:
;  - initial release


; game hooks
;org $80A7A4 ;worked but interferes some aprt of the game
org $80B8DC ;like 11 beeps and song  goes fine
JSL MsuTrack1

;org $80FD1B
;JSL spc2msu

; free rom space for patch code
org $03FCF0

MsuTrack1:
PHA
TXA
PHP ;save processor status
SEP #$20
lda $2002
CMP #$53
BEQ $07
PLP ;restore processor status
PLA
INC $74
LDX $6A
RTL
PLP ;restore processor status
PLA ;get track number from stack
PHA
TXA
PHP ;save processor status again
SEP #$20
JSL msuRoutine1
PLP ;restore processor status
PLA
INC $74
LDX $6A
RTL	

msuRoutine1:
CMP $7EFFFF ; is $80B8DC track playing again?
BEQ noMsuTrack1 ; ignore if trying to play again
STZ $2006
STA $2004
STA $7EFFFF ; store current track in RAM
STZ $2005
loop3:
bit $2000
BVS loop3
LDA #$03
STA $2007
LDA #$FF
STA $2006
noMsuTrack1:
RTL